package com.zcloud.controller.bus;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;
import org.apache.commons.io.FileUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;

import com.zcloud.util.Smb;
import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.util.Const;
import com.zcloud.util.DateUtil;
import com.zcloud.util.FileUpload;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.PathUtil;
import com.zcloud.util.Tools;
import com.zcloud.entity.PageData;
import com.zcloud.service.bus.ImgFilesService;

/** 
 * 说明：图片管理
 * 作者：luoxiaobao
 * 时间：2020-12-24
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/imgfiles")
public class ImgFilesController extends BaseController {
	
	@Autowired
	private ImgFilesService imgfilesService;
	
	/**完成
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add", headers = "content-type=multipart/form-data")
	@ResponseBody
	@Transactional
	public Object finish(
			@RequestParam(value="FFILE",required=false) MultipartFile[] files,
			@RequestParam(value="TYPE",required=false) String TYPE,
			@RequestParam(value="FOREIGN_KEY",required=false) String FOREIGN_KEY
			) throws Exception{
		PageData pd1 = new PageData();
		pd1 = this.getPageData();
		System.out.println(pd1.get("FFILE"));
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		System.out.println(files);
        if (files != null && files.length > 0) {
            for (int i = 0; i < files.length; i++) {
                MultipartFile file = files[i];
//                 保存文件
                File tempFile = new File(file.getOriginalFilename());
        		FileUtils.copyInputStreamToFile(file.getInputStream(), tempFile);
        		if(!FileUpload.isImage(tempFile) && !TYPE.equals("2")) {//四色图改为json文件,不用判断类型	
        			map.put("result", "failed");
        			map.put("exception", "上传图片格式不正确，请重新上传");
        			return map;
        		}
        		tempFile.delete();
        		
        		if(TYPE.equals("2") && pd1.get("EDITFOURTYPE") != null 
        				&& Tools.notEmpty(pd1.get("EDITFOURTYPE").toString()) && pd1.get("EDITFOURTYPE").toString().equals("false")) {//先删除原四色图(json)
        			PageData pd2 = new PageData();
        			pd2.put("FOREIGN_KEY",FOREIGN_KEY);
        			pd2.put("TYPE",TYPE);
        			List<PageData> four = imgfilesService.listAll(pd2);
        			for (PageData pageData : four) {
        				File old = new File(PathUtil.getProjectpath()+pageData.getString("FILEPATH"));
        				old.delete();
        				imgfilesService.delete(pageData);
					}
        		}
        		String  ffile = DateUtil.getDays();
        		String filePath = PathUtil.getProjectpath() + Const.FILEPATHFILE + ffile;	//文件上传路径
        		String fileName = "";				//执行上传
        		
        		if (null != file && !file.isEmpty()) {
//        			String filePath = PathUtil.getProjectpath() +"/"+ Const.FILEPATHYHTP + ffile;	//文件上传路径
        			//fileName = FileUpload.fileUp(file, filePath, this.get32UUID());				//执行上传
        			 fileName = this.get32UUID()+file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
        			 byte[] bytes = file.getBytes();
        			 Smb.sshSftp(file, fileName,Const.FILEPATHYHTP + ffile);
        		}
        		PageData pd = new PageData();
        		pd.put("IMGFILES_ID",  this.get32UUID());
        		pd.put("FILEPATH", Const.FILEPATHYHTP + ffile+"/"+fileName);
        		pd.put("TYPE", TYPE);
        		pd.put("FOREIGN_KEY",  FOREIGN_KEY);
        		imgfilesService.save(pd);
            }
        }
		
		map.put("result", errInfo);
		return map;
	}
	
	
	/**完成
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit", headers = "content-type=multipart/form-data")
	@ResponseBody
	@Transactional
	public Object edit(
			@RequestParam(value="FFILE",required=false) MultipartFile[] files,
			@RequestParam(value="TYPE",required=false) String TYPE,
			@RequestParam(value="FOREIGN_KEY",required=false) String FOREIGN_KEY
			) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
        if (files != null && files.length > 0) {
			PageData pd2 = new PageData();
			pd2.put("FOREIGN_KEY",FOREIGN_KEY);
			pd2.put("TYPE",TYPE);
			List<PageData> four = imgfilesService.listAll(pd2);
			for (PageData pageData : four) {
				File old = new File(PathUtil.getProjectpath()+pageData.getString("FILEPATH"));
				old.delete();
				imgfilesService.delete(pageData);
			}
            for (int i = 0; i < files.length; i++) {
                MultipartFile file = files[i];
//                 保存文件
                File tempFile = new File(file.getOriginalFilename());
        		FileUtils.copyInputStreamToFile(file.getInputStream(), tempFile);
        		if(!FileUpload.isImage(tempFile) && !TYPE.equals("2")) {//四色图改为json文件,不用判断类型	
        			map.put("result", "failed");
        			map.put("exception", "上传图片格式不正确，请重新上传");
        			return map;
        		}
        		tempFile.delete();
        		
        		String  ffile = DateUtil.getDays();
        		String filePath = PathUtil.getProjectpath() + Const.FILEPATHFILE + ffile;	//文件上传路径
        			String fileName = "";				//执行上传
        		
        		if (null != file && !file.isEmpty()) {
//        			String filePath = PathUtil.getProjectpath() +"/"+ Const.FILEPATHYHTP + ffile;	//文件上传路径
        			//fileName = FileUpload.fileUp(file, filePath, this.get32UUID());				//执行上传
        			fileName = this.get32UUID()+file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
        			byte[] bytes = file.getBytes();
        			Smb.sshSftp(file, fileName,Const.FILEPATHYHTP + ffile);
        		}
        		PageData pd = new PageData();
        		pd.put("IMGFILES_ID",  this.get32UUID());
        		pd.put("FILEPATH",  Const.FILEPATHYHTP + ffile + "/" + fileName);
        		pd.put("TYPE", TYPE);
        		pd.put("FOREIGN_KEY",  FOREIGN_KEY);
        		imgfilesService.save(pd);
            }
        }
		
		map.put("result", errInfo);
		return map;
	}
	
	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = imgfilesService.findById(pd);	//根据ID读取
		File file = new File(PathUtil.getProjectpath()+pd.getString("FILEPATH"));
		file.delete();
		imgfilesService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}
	
	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	@RequiresPermissions("imgfiles:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		imgfilesService.edit(pd);
		map.put("result", errInfo);
		return map;
	}
	
	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	@RequiresPermissions("imgfiles:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		page.setPd(pd);
		List<PageData>	varList = imgfilesService.list(page);	//列出ImgFiles列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}
	
	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	@RequiresPermissions("imgfiles:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = imgfilesService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}	
	
	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	@RequiresPermissions("imgfiles:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();		
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			imgfilesService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}
	
	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	@RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("路径");	//1
		titles.add("类型");	//2
		titles.add("外键");	//3
		dataMap.put("titles", titles);
		List<PageData> varOList = imgfilesService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("FILEPATH"));	    //1
			vpd.put("var2", varOList.get(i).get("TYPE").toString());	//2
			vpd.put("var3", varOList.get(i).getString("FOREIGN_KEY"));	    //3
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}
	
}
